﻿using Microsoft.AspNetCore.Http.Extensions;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;

namespace LJProxy.Controllers
{
    [Route("api/[controller]")]
    public class TestController : Controller
    {
        private readonly IHttpClientFactory _clientFactory;
        public TestController(IHttpClientFactory clientFactory)
        {
            _clientFactory = clientFactory;
        }

        [Route("postapi/{apiName}")]
        [HttpPost]
        public async Task<IActionResult> PostApi(string apiName)
        {
            string requestBody;
            using (StreamReader reader = new StreamReader(Request.Body, Encoding.UTF8))
            {
                requestBody = await reader.ReadToEndAsync();
            }
            string url = $"http://127.0.0.1:58966/api/l1svr/svr/{apiName}";
            var content = new StringContent(requestBody, Encoding.UTF8,"application/json");
            var client = _clientFactory.CreateClient();
            var response = await client.PostAsync(url, content);
            string result = await response.Content.ReadAsStringAsync();
            return Content(result, "application/json");

        }

    }
}
